sh = { shadow = {} }

for id = 1, 32 do
	sh.shadow[id] = false
end

-- The script doesn't use this function --
function sh.reloadShadow(id)            --
	if sh.shadow[id] then               --
		freeimage(sh.shadow[id])        --
		sh.shadow[id] = false           --
	end                                 --
	sh.makeShadow(id)                   --
end                                     --
-- The script doesn't use this function --

function sh.removeShadow(id)
	if sh.shadow[id] then
		freeimage(sh.shadow[id])
		sh.shadow[id] = false
	end
end

function sh.startShadow()
	for _, id in pairs(player(0,'tableliving')) do
		if sh.shadow[id] then
			freeimage(sh.shadow[id])
			sh.shadow[id] = false
			sh.makeShadow(id)
		end
	end
end

function sh.makeShadow(id)
	if player(id,'exists') then
		if player(id,'health') > 0 then
			if not sh.shadow[id] then
				sh.shadow[id] = image('gfx/shadow.png',player(id,'x'),player(id,'y'),0)
				imagealpha(sh.shadow[id],0.6)
				return false
			else
				imagepos(sh.shadow[id],player(id,'x'),player(id,'y'),0)
				imagealpha(sh.shadow[id],0.6)
				return true
			end
		end
	end
end

function sh.always()
	for _, id in pairs(player(0,'tableliving')) do
		if sh.makeShadow(id) then
			imagepos(sh.shadow[id],(object(sh.shadow[id],'x') + 3),(object(sh.shadow[id],'y') + 3),player(id,'rot'))
		end
	end
end

addhook('startround','sh.startShadow')
addhook('leave','sh.removeShadow')
addhook('spawn','sh.makeShadow')
addhook('die','sh.removeShadow')
addhook('always','sh.always')